routes/web.php
<?php

use App\Http\Controllers\ProfileController;
use App\Http\Controllers\QuestionsController;
use App\Http\Controllers\AnswersController;
use App\Http\Controllers\FavouritesController;
use App\Http\Controllers\VotesController;
use App\Http\Controllers\UsersController;





use Illuminate\Support\Facades\Route;

Route::get('/', function () {
    return view('welcome');
});

Route::get('/dashboard', function () {
    return view('dashboard');
})->middleware(['auth', 'verified'])->name('dashboard');

Route::middleware('auth')->group(function () {
    Route::get('/profile', [ProfileController::class, 'edit'])->name('profile.edit');
    Route::patch('/profile', [ProfileController::class, 'update'])->name('profile.update');
    Route::delete('/profile', [ProfileController::class, 'destroy'])->name('profile.destroy');
});

require __DIR__.'/auth.php';

Route::resource('questions', QuestionsController::class)->except(['show']);
Route::get('/questions/{slug}', [QuestionsController::class,'show'])->name('questions.show');

Route::resource('questions.answers', AnswersController::class)->except(['show','index','create']);
Route::put('/questions/{question}/answers/{answer}/markAsBest',[AnswersController::class,'markAsBest'])->name('questions.answers.markAsBest');
 Route::post('/questions/{question}/mark-as-fav',[FavouritesController::class,'store'])->name('questions.favourite');
 Route::delete('/questions/{question}/mark-as-unfav',[FavouritesController::class,'destroy'])->name('questions.unfavourite');
 Route::post('/questions/{question}/vote/{vote}',[VotesController::class,'voteQuestion'])->name('questions.vote');

 Route::get('users/notifications',[UsersController::class,'notifications'])->name('users.notifications');

app/Models/Question.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Str;


class Question extends Model
{
    use HasFactory;

    protected $guarded = [];

    public function setTitleAttribute($title)
    {
        $this->attributes['title'] = $title;
        $this->attributes['slug'] = Str::slug($title);
    }
    public function getUrlAttribute() {
        return "questions/{$this->slug}";
    }
    public function getCreatedDateAttribute()
    {
        return $this->created_at->diffForHumans();
    }

    public function getAnswerStyleAttribute() {
        if($this->answers_count > 0) {
            if($this->best_answer_id) {
                return "has-best-answer";
            }
            return "answered";
        }
        return "unanswered";
    }
    public function getFavouritesCountAttribute()
    {
        return $this->favourites()->count();
    }
    public function getIsFavouriteAttribute()
    {
        return $this->favourites()->where('user_id',auth()->id())->count() > 0;
    }
    public function owner()
    {
        return $this->belongsTo(User::class,'user_id');
    }

    public function answers()
    {
        return $this->hasMany(Answer::class);
    }

    public function favourites()
    {
        return $this->belongsToMany(User::class)->withTimeStamps();
    }
    public function markBestAnswer(Answer $answer)
    {
        $this->best_answer_id = $answer->id;
        $this->save();
    }
    public function vote(int $vote)
    {
        $this->votes()->attach(auth()->id(), ['vote'=>$vote]);
        if($vote < 0) {
            $this->decrement('votes_count');
        } else {
            $this->increment('votes_count');
        }
    }
    public function updateVote(int $vote)
    {
        $this->votes()->updateExistingPivot(auth()->id(), ['vote'=>$vote]);
        if($vote < 0) {
            $this->decrement('votes_count');
            $this->decrement('votes_count');

        } else {
            $this->increment('votes_count');
            $this->increment('votes_count');

        }
    }

    public function votes()
    {
        return $this->morphToMany(User::class,'vote')->withTimestamps()->withPivot(['vote']);
    }


}

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * Get the attributes that should be cast.
     *
     * @return array<string, string>
     */
    protected function casts(): array
    {
        return [
            'email_verified_at' => 'datetime',
            'password' => 'hashed',
        ];
    }
    public function questions()
    {
        return $this->hasMany(Question::class);
    }

    public function answers()
    {
        return $this->hasMany(Answer::class);
    }

    public function favourites()
    {
        return $this->belongsToMany(Question::class)->withTimestamp();
    }

    public function votesQuestions()
    {
        return $this->morphedByMany(Question::class,'vote')->withTimestamps();
    }

    public function votesAnswers()
    {
        return $this->morphedByMany(Answer::class,'vote')->withTimestamps();
    }
    public function hasUpVoteForQuestion(Question $question)
    {
        return $this->votesQuestions()->where(['vote'=> 1,'vote_id' => $question->id])->exists();
    }

    public function hasDownVoteForQuestion(Question $question)
    {
        return $this->votesQuestions()->where(['vote'=> -1,'vote_id' => $question->id])->exists();
    }
    public function hasVoteForQuestion(Question $question)
    {
        return $this->hasUpVoteForQuestion($question) || $this->hasDownVoteForQuestion($question);
    }
    public function getAvatarAttribute()
    {
        $size =40;
        return "https://ui-avatars.com/api/?name={$this->name}&rounded=true&size={$size}";
    }
}

app/Http/Controllers/QuestionsController.php
<?php

namespace App\Http\Controllers;

use App\Models\Question;
use Illuminate\Http\Request;
use App\Http\Requests\Question\CreateQuestionRequest;
use App\Http\Requests\Question\UpdateQuestionRequest;

use Illuminate\Support\Facades\Gate;

use Illuminate\Routing\Controllers\HasMiddleware;
use Illuminate\Routing\Controllers\Middleware;


class QuestionsController extends Controller implements HasMiddleware
{
    /**
     * Display a listing of the resource.
     */
    public static function middleware(): array{
        return [
            new Middleware('auth',only:['create','store']),
            new Middleware('trackQuestionView',only:['show']),
        ];
    }
    public function index()
    {
        $questions = Question::with('owner')->latest()->paginate(10);
        return view('qa.questions.index',compact(['questions']));
    }

    /**
     * Show the form for creating a new resource.
     */
    public function create()
    {
        return view('qa.questions.create');
    }

    /**
     * Store a newly created resource in storage.
     */
    public function store(CreateQuestionRequest $request)
    {
        auth()->user()->questions()->create([
            'title'=> $request->title,
            'body'=> $request->body
        ]);

        session()->flash('success','Question has been added successfully!');
        return redirect(route('questions.index'));
    }

    /**
     * Display the specified resource.
     */
    public function show(Question $question)
    {
        return view('qa.questions.show',compact(['question']));
    }

    /**
     * Show the form for editing the specified resource.
     */
    public function edit(Question $question)
    {
        // if(! Gate::allows('update',$question)) {
        //     abort(403);
        // }

        Gate::authorize('update',$question);
        return view('qa.questions.edit',compact(['question']));
    }

    /**
     * Update the specified resource in storage.
     */
    public function update(UpdateQuestionRequest $request, Question $question)
    {
        Gate::authorize('update',$question);
        $question->update([
            'title'=> $request->title,
            'body' => $request->body
        ]);

        session()->flash('success','Question has been updated successfully!');
        return redirect(route('questions.index'));
    }

    /**
     * Remove the specified resource from storage.
     */
    public function destroy(Question $question)
    {
        Gate::authorize('delete',$question);
        $question->delete();
        session()->flash('success','Question has been updated successfully!');
        return redirect(route('questions.index'));
    }
   
}

resources/views/qa/questions/create.blade.php
@extends('qa.layouts.app')

@section('page-level-styles')
<link rel="stylesheet" type="text/css" href="https://unpkg.com/trix@2.0.8/dist/trix.css">
@endsection

@section('page-level-scripts')
<script type="text/javascript" src="https://unpkg.com/trix@2.0.8/dist/trix.umd.min.js"></script>
@endsection

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header"><h2>Ask aQuestion!</h2></div>
                    <div class="card-body">
                        <form action="{{ route('questions.store')}}" method="POST" enctype="multipart/form-data">
                            @csrf
                            <div class="form-group mb-4">
                                <label for="title" class="form-label">Title</label>
                                <input type="text" name="title" id="title" placeholder="Enter Question Title!" value="{{ old('title')}}" class="form-control {{ $errors->has('title') ? 'is-invalid' : ''}}">
                                @error('title')
                                <div class="text-danger text-sm">{{ $message }}</div>
                                @enderror
                            </div>

                            <div class="form-group mb-4">
                                <label for="body" class="form-label">Enter your Question</label>
                                <input id="body" type="hidden" name="body" value="{{ old('body')}}">
                                <trix-editor input="body" class="form-control {{ $errors->has('body') ? 'is-invalid' : ''}}"></trix-editor>
                                @error('body')
                                    <div class="text-danger text-sm">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-outline-primary">Submit</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/qa/questions/edit.blade.php
@extends('qa.layouts.app')

@section('page-level-styles')
<link rel="stylesheet" type="text/css" href="https://unpkg.com/trix@2.0.8/dist/trix.css">
@endsection

@section('page-level-scripts')
<script type="text/javascript" src="https://unpkg.com/trix@2.0.8/dist/trix.umd.min.js"></script>
@endsection

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header"><h2>Ask aQuestion!</h2></div>
                    <div class="card-body">
                        <form action="{{ route('questions.update',$question->id) }}" method="POST" enctype="multipart/form-data">
                            @csrf
                            @method('PUT')
                            <div class="form-group mb-4">
                                <label for="title" class="form-label">Title</label>
                                <input type="text" name="title" id="title" placeholder="Enter Question Title!" value="{{ old('title',$question->title)}}" class="form-control {{ $errors->has('title') ? 'is-invalid' : ''}}">
                                @error('title')
                                <div class="text-danger text-sm">{{ $message }}</div>
                                @enderror
                            </div>

                            <div class="form-group mb-4">
                                <label for="body" class="form-label">Enter your Question</label>
                                <input id="body" type="hidden" name="body" value="{{ old('body',$question->body)}}">
                                <trix-editor input="body" class="form-control {{ $errors->has('body') ? 'is-invalid' : ''}}"></trix-editor>
                                @error('body')
                                    <div class="text-danger text-sm">{{ $message }}</div>
                                @enderror
                            </div>
                            <div class="form-group">
                                <button type="submit" class="btn btn-outline-primary">Submit</button>
                            </div>
                        </form>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/qa/questions/index.blade.php
@extends('qa.layouts.app')

@section('content')
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header d-flex justify-content-between">
                        <h2>All Questions</h2>
                        @auth
                        <a href="{{ route('questions.create') }}" class="btn btn-outline-primary">Ask a Question!</a>
                        @endauth
                    </div>
                    <div class="row">
                        @foreach ($questions as $question)
                            <div class="col-md-2">
                                <div class="d-flex flex-column mr-4 statistics">
                                    <div class="votes text-center mb-3">
                                        <strong class="d-block"> {{ $question->votes_count }} </strong> Votes
                                    </div>
                                    <div class="text-center mb-3">
                                        <div class="answers {{ $question->answer_style }}"
                                            style="max-width: 60%; margin:0 auto;">
                                            <strong class="d-block"> {{ $question->answers_count }}</strong>Answers
                                        </div>
                                    </div>
                                    <div class="views text-center">
                                        <strong class="d-block">{{ $question->views_count }}</strong> Views
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-10">
                                <div class="card-body">
                                    <div class="card-title">
                                        <div class="d-flex justify-content-between">
                                            <h3>
                                                <a href="{{ $question->url }}">{{ $question->title }}</a>
                                            </h3>
                                            <div >
                                                @can('edit-question',$question)
                                                <a href="{{ route('questions.edit', $question->id) }}"
                                                    class="btn btn-sm btn-outline-warning">Edit</a>
                                                @endcan
                                                @can('delete',$question)
                                                <form action="{{ route('questions.destroy', $question->id) }}" method="POST" class="d-inline-block">
                                                    @csrf
                                                    @method('DELETE')
                                                    <button type="submit" class="btn btn-sm btn-outline-danger">Delete</button>
                                                </form>
                                                @endcan

                                            </div>
                                        </div>

                                        <p>Asked By: <a href="#">{{ $question->owner->name }}</a>
                                            <span class="text-muted">{{ $question->created_date }}</span>
                                        </p>
                                        <p>{!! Str::limit($question->body, 250) !!}</p>
                                    </div>
                                </div>
                            </div>
                            <hr>
                        @endforeach
                    </div>

                    <div class="card-footer">
                        {{ $questions->links() }}
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/qa/questions/show.blade.php
@extends('qa.layouts.app')

@section('page-level-styles')
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.5.2/css/all.min.css" integrity="sha512-SnH5WK+bZxgPHs44uWIX+LLJAJ9/2PkPKZ5QiAj6Ta86w+fsb2TkcmfRyVX3pBnMFcV7oQPJkl9QevSCWr3W6A==" crossorigin="anonymous" referrerpolicy="no-referrer" />
<link rel="stylesheet" type="text/css" href="https://unpkg.com/trix@2.0.8/dist/trix.css">
@endsection

@section('page-level-scripts')
<script type="text/javascript" src="https://unpkg.com/trix@2.0.8/dist/trix.umd.min.js"></script>
@endsection

@section('content')
    <div class="container">
        <div class="row mb-2">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header">
                        <h1>{{ $question->title }}</h1>
                    </div>
                    <div class="card-body">{!! $question->body !!}</div>
                    <div class="card-footer">
                        <div class="d-flex justify-content-between mr-3">
                            <div class="d-flex">
                                <div>
                                    @auth
                                        <form action="{{ route('questions.vote',[$question,1]) }}" method="POST" >
                                            @csrf
                                            <button type="submit" title="Up Vote" class="vote-up d-block text-center {{ auth()->user()->hasUpVoteForQuestion($question) ? 'text-success' : 'text-dark' }}">
                                                <i class="fa fa-caret-up fa-3x"></i>
                                            </button>
                                        </form>
                                        <h4 class="votes-count text-muted text-center m-0">{{ $question->votes_count }} </h4>


                                        <form action="{{ route('questions.vote',[$question,-1]) }}" method="POST" >
                                            @csrf
                                            <button type="submit" title="Down Vote" class="vote-down d-block text-center {{ auth()->user()->hasDownVoteForQuestion($question) ? 'text-danger' : 'text-dark' }}">
                                                <i class="fa fa-caret-down fa-3x"></i>
                                            </button>
                                        </form>
                                    @endauth

                                </div>
                                <div class="m-4 text-center {{ $question->is_favourite ? 'text-warning' : 'text-black'}}">
                                    <form action="{{ route($question->is_favourite ? 'questions.unfavourite' : 'questions.favourite', $question) }}" method="POST">
                                        @csrf
                                        @if($question->is_favourite)
                                            @method('DELETE')
                                        @endif
                                        <button type="submit" title="{{ $question->is_favourite ? 'Mark as Unfav' : 'Mark as Fav'}}"> <i class="fa fa-star fa-2x "></i>
                                        </button>
                                        <h4>
                                            {{ $question->favourites_count}}
                                        </h4>
                                    </form>
                                </div>
                            </div>
                            <div class="d-flex flex-column">
                                <div class="text-muted mb-2 text-right">
                                    Asked At: {{ $question->created_date }}
                                </div>
                                <div class="d-flex mb-2">
                                    <div><img src="{{ $question->owner->avatar }}"
                                            alt="Avatar of  {{ $question->owner->name }}">
                                    </div>
                                    <div class="m-2">
                                        {{ $question->owner->name }}
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        @auth
            @include('qa.answers._create')
        @endauth
        @include('qa.answers._index')

    </div>
@endsection